/* 
   $Id: sgmemo.h,v 1.6 2001/12/25 10:41:54 sho Exp $

   Copyright (C) 2001,2002 AXE,Inc. <sg@axe-inc.co.jp>

   This file is part of sgmemo.

   sgmemo is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   sgmemo is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with sgmemo; see the file COPYING.   If not, write to
   the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA. */

#include <gtk/gtk.h>
#include <gdk/gdk.h>
#include <gdk/gdktypes.h>
#include <gdk/gdkkeysyms.h>

#define ENABLE_NLS 1
#include <gnome.h>

#include "sg_aplaunch.h"

#define MAX_MEMOS  512

#define MAX_CATEGORY	16
#define MAX_CATEGORY_LENGTH	20

#define MAX_STROKE 128
#define MAX_SAMP   512

#define STATE_TOP	1
#define STATE_VIEW	2
#define STATE_WRITE	3
#define STATE_DRAW	4

#define CHECK_TEXTONLY		( 1<<0 )
#define CHECK_STROKONLY		( 1<<1 )
#define CHECK_ALL		( CHECK_TEXTONLY | CHECK_STROKONLY )

typedef struct _point{
  short x, y;
}point;

typedef struct _stroke{
  int   n_sample;
  point sample[MAX_SAMP];
}stroke;

typedef struct _memolist_t{
  int   flag;
  char  *name;
}memolist_t;

void select_category_menu();
void save_memo(int num, char *str);
char *load_memo(int num);
int load_stroke(int num, stroke *stk);
void save_stroke(int num, stroke *stk, int n_stroke);
void remove_memo(int num);
void remove_stroke(int num);
void load_memo_list();
void save_memo_list();
int  renumber_filename();

void load_category_data();

void press_edit_button(GtkWidget *widget, gpointer data);
void press_quit_button(GtkWidget *widget, gpointer data);

void copy_text();
void cut_text();
void paste_text();

void copy_memo();
void cut_memo();
void paste_memo();

int get_blank_slot( int value, int start_no );

