/* 
   $Id: sgmemo_main.c,v 1.10 2001/12/25 10:41:54 sho Exp $

   Copyright (C) 2001,2002 AXE,Inc. <sg@axe-inc.co.jp>

   This file is part of sgmemo.

   sgmemo is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   sgmemo is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with sgmemo; see the file COPYING.   If not, write to
   the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA. */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <X11/X.h>
#include <gdk/gdkx.h>

#include "sgmemo.h"

#include "config.h"

GtkWidget *window;
GtkWidget *notebook;

GtkWidget *main_container_vbox;
GtkWidget *main_container_top_vbox;
GtkWidget *main_container_view_vbox;

GtkWidget *memo_table;
GtkWidget *memo_box;
GtkWidget *buttons_view;
GtkWidget *buttons_write;

GtkWidget *btnNew;
GtkWidget *btnEdit;
GtkWidget *btnDelete;
GtkWidget *btnReturn;
GtkWidget *lblDummy;
GtkWidget *btnUndo;
GtkWidget *btnRedo;
GtkWidget *btnAdd;
GtkWidget *btnCancel;

GtkWidget *draw_toggle;

GtkWidget *list;
GtkWidget *list_table;
GtkWidget *list_vscroll;
GtkObject *adjustment;

GtkWidget *memo_text;
GtkWidget *memo_vscroll;

static GnomeUIInfo main_menu[] = {

  {
    GNOME_APP_UI_ITEM,
    N_("Category"), NULL,
    GTK_SIGNAL_FUNC(select_category_menu), NULL, NULL,
    GNOME_APP_PIXMAP_NONE , NULL,
    0, GDK_CONTROL_MASK, NULL
  },

  {
    GNOME_APP_UI_ITEM,
    N_("Quit"), NULL,
    GTK_SIGNAL_FUNC(press_quit_button), NULL, NULL,
    GNOME_APP_PIXMAP_STOCK , GNOME_STOCK_MENU_QUIT,
    0, GDK_CONTROL_MASK, NULL
  },

  GNOMEUIINFO_END
};


char   *memos[MAX_MEMOS];
int    current_memos = -1;

memolist_t   memo_list[MAX_MEMOS];	/* ȥƥбդԤե */

int	disp_status;

int    has_copy = 0;
char   *copy_str;
stroke copy_stk[MAX_STROKE];
int    copy_stroke = 0;

stroke stk[MAX_STROKE];
int    undo      = 0;
int    n_stroke  = 0;
int    n_sample  = 0;
int    draw_flag = 0;

char *c_array[MAX_CATEGORY];
int array_tail_cate=0;

void set_display_state( int status )
{
  disp_status = status;

  switch( status ){
  case STATE_TOP:
    gtk_widget_show( main_container_top_vbox );
    gtk_widget_hide( main_container_view_vbox );
	sgmemo_nunome_popup( FALSE );
    break;

  case STATE_VIEW:
    gtk_widget_show( main_container_view_vbox );
    gtk_widget_hide( main_container_top_vbox );
    gtk_widget_show( buttons_view );
    gtk_widget_hide( buttons_write );
	sgmemo_nunome_popup( FALSE );
    break;

  case STATE_WRITE:
    gtk_widget_hide( main_container_view_vbox );
    gtk_widget_show( main_container_view_vbox );
    gtk_widget_hide( main_container_top_vbox );
    gtk_widget_hide( buttons_view );
    gtk_widget_hide( lblDummy );
    gtk_widget_hide( btnUndo );
    gtk_widget_hide( btnRedo );
    gtk_widget_show( buttons_write );
	sgmemo_nunome_popup( TRUE );
    break;

  case STATE_DRAW:
    gtk_widget_show( main_container_view_vbox );
    gtk_widget_hide( main_container_top_vbox );
    gtk_widget_hide( buttons_view );
    gtk_widget_show( buttons_write );
    gtk_widget_show( lblDummy );
    gtk_widget_show( btnUndo );
    gtk_widget_show( btnRedo );
	sgmemo_nunome_popup( FALSE );
    break;

  }
}


void select_category_menu()
{
  system( "sgcate &" );
}


/*
** ܤ
*/
void sgmemo_nunome_popup( int mode )
{
    XClientMessageEvent ev;
    Atom atom;
	Display *dpy;

	dpy = XOpenDisplay(NULL);

	if( mode == TRUE ){
		atom = XInternAtom( dpy, "_AXE_SGWM_MAP_NUNOME", False );
	}else{
		atom = XInternAtom( dpy, "_AXE_SGWM_UNMAP_NUNOME", False );
	}

	ev.type = ClientMessage;
	ev.window = DefaultRootWindow(dpy);
	ev.message_type = atom;
	ev.format = 32;

	XSendEvent( dpy, DefaultRootWindow(dpy), False,
				SubstructureNotifyMask, (XEvent *)&ev );

    XSync( dpy, False );
}

char *get_first_line(char *str)
{
  int  len;
  char *ret = NULL;
  char *p = NULL, *q = NULL;

  if(str != NULL){
    len = strlen(str);

    if(len > 0){ 
      q = str;
      do{
	p = strchr(q, '\n');
	if(p && ((p - q) > 0)){
	  ret = (char *) calloc(1, (p - q + 1)*sizeof(char));
	  strncpy(ret, q, p - q);
	  break;
	}else if(!p && strlen(q) > 0){
	  ret = strdup(q);
	  break;
	}
	q = p + 1;
      }while(p);
    }
  }

  return ret;
}

void disp_memo_list( int page )
{
  int i;
  char *strs[4];
  char num[256];
  char idx[256];

  if( page < 0 || page > array_tail_cate ){
    return;
  }

  gtk_clist_clear( GTK_CLIST(list) );

  strs[0] = num;
  strs[2] = idx;
  strs[3] = NULL;
  
  for(i = 0; i < MAX_MEMOS; i++){

    if( memo_list[i].flag == 0 ){
	  break;
	}

    if( page == 0
    ||  ( memo_list[i].name != NULL
        && strcmp(memo_list[i].name, c_array[page-1]) == 0 ) ){

      sprintf(num, "%d", i + 1);
      strs[1]  = get_first_line(memos[i]);
      sprintf( idx, "%d", i );
      gtk_clist_append(GTK_CLIST(list), strs);
      if(strs[1]) free(strs[1]), strs[1] = NULL;

	}

  }

}


void disp_memo_list_all( int page )
{
  int i;

  if( page < 0 || page > array_tail_cate ){
    return;
  }

  for(i = 0; i < MAX_MEMOS; i++){

    if( memo_list[i].flag == 0 ){
	  break;
	}

    memos[i] = load_memo(i);

  }

  disp_memo_list( page );

}



void
switch_page( GtkNotebook *notebook, GtkNotebookPage *page, guint page_num )
{
  disp_memo_list_all( page_num );
}


void get_memo(int num)
{
  char *tmp, *p;
  int  len;

  if(memo_text == NULL) return;

  len = gtk_text_get_length(GTK_TEXT(memo_text));
  tmp = gtk_editable_get_chars(GTK_EDITABLE(memo_text), 0, len);
  
  if(tmp != NULL){
    if(memos[num] != NULL) free(memos[num]);
    memos[num] = NULL;

    if(len > 0) memos[num] = strdup(tmp);

    p = get_first_line(memos[num]);

    gtk_clist_set_text(GTK_CLIST(list), num, 1, p);
    if(p) free(p);
  }

  save_memo(num, memos[num]);

}

void set_memo(int num)
{
  if(memos[num]!=NULL){
    gtk_editable_delete_text(GTK_EDITABLE(memo_text), 0, -1);
    gtk_text_insert(GTK_TEXT(memo_text),
		    NULL, NULL,	NULL,
		    memos[num], strlen(memos[num]));
  }else{
    gtk_editable_delete_text(GTK_EDITABLE(memo_text), 0, -1);
  }
}

void 
select_row(GtkWidget *list, gint row, gint column, GdkEventButton *event, gpointer data)
{
  char *text;
  int seq_no;

  gtk_clist_get_text( GTK_CLIST(list), row, 2, &text );

  seq_no = atoi(text);

  current_memos = seq_no;
  if( current_memos < 0 || current_memos >= MAX_MEMOS )
  	return;

  if( memo_list[current_memos].flag != 0 ){
    n_stroke = load_stroke(current_memos, stk);
    n_sample = 0;
    set_memo(current_memos);
    
    set_display_state( STATE_VIEW );
  }
}

void 
unselect_row(GtkWidget *list, gint row, gint column, GdkEventButton *event, gpointer data)
{
  current_memos = -1;
}

void quit(GtkWidget *widget, GdkEvent *event, gpointer data)
{
  gtk_main_quit();
  save_memo_list();
}

void close_dialog(GtkWidget *widget, gpointer data)
{
  gtk_grab_remove(widget);
}

void yes_delete(GtkWidget *widget, gpointer data)
{
  int i;

  if(current_memos < 0) return;

  if(memos[current_memos]){
    free(memos[current_memos]);
    memos[current_memos] = NULL;
    remove_memo(current_memos);

  }

  for( i=current_memos; i<MAX_MEMOS-1; i++ ){
  	memos[i] = memos[i+1];
  	memos[i+1] = NULL;
  }

  if(n_stroke > 0){
    remove_stroke(current_memos);
    n_stroke = 0;
  }

  renumber_filename();

  /*
  gtk_clist_set_text(GTK_CLIST(list), current_memos, 1, NULL);
  */

  gtk_editable_delete_text(GTK_EDITABLE(memo_text), 0, -1);

  gtk_widget_destroy(GTK_WIDGET(data));

  current_memos = -1;

  disp_memo_list( 0 );

  set_display_state( STATE_TOP );
}

void no_delete(GtkWidget *widget, gpointer data)
{
  gtk_widget_destroy(GTK_WIDGET(data));
}

void
message_btn(char *message, void (*y_func)(), void (*n_func)())
{
  GtkWidget *dialog;
  GtkWidget *d_mesg;
  GtkWidget *y_btn, *n_btn;

  dialog = gtk_dialog_new();

  gtk_signal_connect(GTK_OBJECT(dialog), "destroy",
		     GTK_SIGNAL_FUNC(close_dialog), NULL);

  gtk_window_set_title(GTK_WINDOW(dialog), NULL);

  d_mesg = gtk_label_new(message);

  gtk_misc_set_padding(GTK_MISC(d_mesg), 10, 10);

  gtk_box_pack_start(GTK_BOX(GTK_DIALOG(dialog)->vbox),
		     d_mesg, TRUE, TRUE, 0);

  y_btn = gtk_button_new_with_label(_("Yes"));
  n_btn = gtk_button_new_with_label(_("No"));

  gtk_signal_connect(GTK_OBJECT(y_btn), "clicked",
		     GTK_SIGNAL_FUNC(y_func), dialog);
  gtk_signal_connect(GTK_OBJECT(n_btn), "clicked",
		     GTK_SIGNAL_FUNC(n_func), dialog);

  gtk_box_pack_start(GTK_BOX(GTK_DIALOG(dialog)->action_area),
		     y_btn, TRUE, TRUE, 0);
  gtk_box_pack_start(GTK_BOX(GTK_DIALOG(dialog)->action_area),
		     n_btn, TRUE, TRUE, 0);

  gtk_widget_show(d_mesg);
  gtk_widget_show(y_btn);
  gtk_widget_show(n_btn);
  gtk_widget_show(dialog);
  gtk_grab_add(dialog);
}

void press_new_button( GtkWidget *widget, gpointer data )
{
  int idx;

  if(current_memos >= 0) return;  /* ꤨʤ */

  idx = get_blank_slot( CHECK_ALL, 0 );
  if( idx < 0 ){
    printf( _("Blank slot not exists.\n") );
    return;
  }

  current_memos = idx;

  if( current_memos < 0 ){
    printf( _("Blank Slot Not Found.\n") );
    return;
  }

  /*
  ** ե뤬ʤΤɬ顼ˤʤ뤬ΤˤƹԤ
  */
  n_stroke = load_stroke(current_memos, stk);
  n_sample = 0;

  set_memo(current_memos);  

  gtk_text_set_editable(GTK_TEXT(memo_text), TRUE);
  gtk_editable_set_position(GTK_EDITABLE(memo_text), 0);
  set_display_state( STATE_WRITE );

}

char *get_category( char *data )
{
  int page;
  char *w_category;

  page = gtk_notebook_get_current_page( GTK_NOTEBOOK(notebook) );

  if( page <= 0 || page > array_tail_cate ){

    w_category = NULL;

  }else{

    if( data == NULL
    ||  strcmp( data, c_array[page-1] ) != 0 ){
      w_category = c_array[page-1];
    }else{
      w_category = data;
    }

  }

  return( w_category );

}


void press_add_button( GtkWidget *widget, gpointer data )
{
  int len;
  int active;
  int page;

  len = gtk_text_get_length(GTK_TEXT(memo_text));

  if( n_stroke <= 0
  &&  len == 0 ){
    return;
  }

  get_memo( current_memos ); /* get & save */

  save_stroke(current_memos, stk, n_stroke);

  memo_list[current_memos].name = get_category( memo_list[current_memos].name );

  memo_list[current_memos].flag = 1;

  save_memo_list();

  active = gtk_toggle_button_get_active( GTK_TOGGLE_BUTTON(draw_toggle) );
  if( active == TRUE ){
    gtk_toggle_button_set_active( GTK_TOGGLE_BUTTON(draw_toggle), FALSE );
  }

  current_memos = -1;
  set_display_state( STATE_TOP );

  page = gtk_notebook_get_current_page( GTK_NOTEBOOK(notebook) );
  disp_memo_list_all( page );
}


void press_return_button( GtkWidget *widget, gpointer data )
{
  if(current_memos < 0) return;  /* ꤨʤ */

  get_memo(current_memos);
  save_stroke(current_memos, stk, n_stroke);

  current_memos = -1;
  set_display_state( STATE_TOP );
}

void press_cancel_button( GtkWidget *widget, gpointer data )
{
  int active;
  int page;

  active = gtk_toggle_button_get_active( GTK_TOGGLE_BUTTON(draw_toggle) );
  if( active == TRUE ){
    gtk_toggle_button_set_active( GTK_TOGGLE_BUTTON(draw_toggle), FALSE );
  }

  gtk_text_set_editable(GTK_TEXT(memo_text), FALSE);

  current_memos = -1;
  set_display_state( STATE_TOP );

  page = gtk_notebook_get_current_page( GTK_NOTEBOOK(notebook) );
  disp_memo_list_all( page );
}


void press_edit_button(GtkWidget *widget, gpointer data)
{
  if(current_memos < 0) return;

  n_stroke = load_stroke(current_memos, stk);
  n_sample = 0;

  set_display_state( STATE_WRITE );

  set_memo(current_memos);  
  gtk_text_set_editable(GTK_TEXT(memo_text), TRUE);
  gtk_editable_set_position(GTK_EDITABLE(memo_text), 0);

}

void press_del_button(GtkWidget *widget, gpointer data)
{
  message_btn(_("Do you want to delete?"), yes_delete, no_delete);
}

void press_quit_button(GtkWidget *widget, gpointer data)
{
  if(current_memos < 0){
    get_memo(current_memos);
    save_stroke(current_memos, stk, n_stroke);
  }
  gtk_main_quit();
}

void init_list()
{
  char *list_titles[3];

  list_titles[0] = _("No.");
  list_titles[1] = _("Title");
  list_titles[2] = _("");

  list_table = gtk_table_new(2, 2, FALSE);

  list = gtk_clist_new_with_titles(3, list_titles);
  gtk_signal_connect (GTK_OBJECT (list), "select_row", 
		      GTK_SIGNAL_FUNC (select_row), NULL);
  gtk_signal_connect (GTK_OBJECT (list), "unselect_row", 
		      GTK_SIGNAL_FUNC (unselect_row), NULL);

  gtk_clist_column_titles_passive(GTK_CLIST(list));
  gtk_clist_set_column_width(GTK_CLIST(list), 2, 5);
  gtk_widget_set_usize(list, 1, 1);

 
  /*
  ** ܤʤΤǸʤ褦ˤ롣
  */
  gtk_clist_set_column_visibility( GTK_CLIST(list), 2, FALSE );


  adjustment = gtk_adjustment_new (0.0, 0.0, 1000000.0, 1.0, 25.0, 25.0);
  gtk_clist_set_vadjustment(GTK_CLIST(list), GTK_ADJUSTMENT(adjustment));
  list_vscroll = gtk_vscrollbar_new(GTK_ADJUSTMENT(adjustment));

  gtk_table_attach(GTK_TABLE(list_table), list, 0, 1, 0, 1,
		   GTK_FILL|GTK_EXPAND, GTK_FILL|GTK_EXPAND, 0, 0);
  
  gtk_table_attach(GTK_TABLE(list_table), list_vscroll, 1, 2, 0, 1,
		   GTK_SHRINK, GTK_FILL|GTK_EXPAND, 0, 0);

  gtk_clist_set_column_justification (GTK_CLIST(list), 0, GTK_JUSTIFY_RIGHT);

  disp_memo_list_all( 0 );

  gtk_widget_show(list);
  gtk_widget_show(list_vscroll);
  gtk_widget_show(list_table);

}

gint
text_button_press(GtkWidget *widget, GdkEventButton *event, gpointer data)
{
  int x,y;
  int start = GTK_TEXT(widget)->first_onscreen_ver_pixel;

  if(undo > 0) undo = 0;

  x = (int) event->x;
  y = (int) event->y + start;

  if((x < 0) || (x > 32767) || (y < 0 ) || (y > 32767))
    return FALSE;

  stk[n_stroke].sample[n_sample].x = (short) x;
  stk[n_stroke].sample[n_sample].y = (short) y;
  n_sample++;
  gtk_text_set_editable(GTK_TEXT(memo_text), FALSE);

#ifdef DEBUG_PRINT
  printf("sample: %d\n", n_sample);
#endif
  return TRUE;
}

gint
text_button_release(GtkWidget *widget, GdkEventButton *event, gpointer data)
{
  GdkWindow *win = GTK_TEXT(widget)->text_area;
  GdkGC     *gc;
  int x1,x2,y1,y2;
  int x,y;
  int start = GTK_TEXT(widget)->first_onscreen_ver_pixel;

  x = (int) event->x;
  y = (int) event->y + start;

  if((x < 0) || (x > 32767) || (y < 0 ) || (y > 32767)){
    stk[n_stroke].n_sample = n_sample;
    n_stroke++;
    n_sample = 0;
    return FALSE;
  }

  if(n_sample > 1){
    gc = widget->style->black_gc;
    stk[n_stroke].sample[n_sample].x = (short) x;
    stk[n_stroke].sample[n_sample].y = (short) y;

    x1 = stk[n_stroke].sample[n_sample - 1].x;
    y1 = stk[n_stroke].sample[n_sample - 1].y;
    x2 = stk[n_stroke].sample[n_sample].x;
    y2 = stk[n_stroke].sample[n_sample].y;

    gdk_draw_line(win, gc, x1, y1 - start, x2, y2 - start);

    stk[n_stroke].n_sample = n_sample;
    n_stroke++;
    n_sample = 0;
  }else{
    n_sample = 0;
  }

  gtk_text_set_editable(GTK_TEXT(memo_text), TRUE);
#ifdef DEBUG_PRINT
  printf("stroke: %d\n", n_stroke);
#endif
  return TRUE;
}

gint
text_motion_notify(GtkWidget *widget, GdkEventMotion *event, gpointer data)
{
  GdkWindow *win = GTK_TEXT(widget)->text_area;
  GdkGC     *gc;
  int       x1,x2,y1,y2;
  int       x,y;
  int start = GTK_TEXT(widget)->first_onscreen_ver_pixel;
  
  x = (int) event->x;
  y = (int) event->y + start;

  if((x < 0) || (x > 32767) || (y < 0 ) || (y > 32767))
    return FALSE;

  if(n_sample > MAX_SAMP){
    stk[n_stroke].n_sample = n_sample;
    n_stroke++;
    n_sample = 0;

    stk[n_stroke].sample[n_sample].x = (short)x;
    stk[n_stroke].sample[n_sample].y = (short)y;
    n_sample++;

  }else  if(n_sample > 0){
    gc = widget->style->black_gc;

    stk[n_stroke].sample[n_sample].x = (short) x;
    stk[n_stroke].sample[n_sample].y = (short) y;

    x1 = stk[n_stroke].sample[n_sample - 1].x;
    y1 = stk[n_stroke].sample[n_sample - 1].y;
    x2 = stk[n_stroke].sample[n_sample].x;
    y2 = stk[n_stroke].sample[n_sample].y;

    gdk_draw_line(win, gc, x1, y1 - start, x2, y2 - start);
    n_sample++;
  }
#ifdef DEBUG_PRINT
  printf("sample: %d\n", n_sample);
#endif
  return TRUE;
}

void draw_stroke(GtkWidget *widget)
{
  GdkWindow *win = GTK_TEXT(widget)->text_area;
  GdkGC     *gc;

  int i, j;
  int x1,x2,y1,y2;
  int start = GTK_TEXT(widget)->first_onscreen_ver_pixel;

  if(!win) return;

  gc = widget->style->black_gc;

  for( i = 0; i < n_stroke; i++){
    for( j = 1; j < stk[i].n_sample; j++){
      x1 = stk[i].sample[j - 1].x;
      y1 = stk[i].sample[j - 1].y;
      x2 = stk[i].sample[j].x;
      y2 = stk[i].sample[j].y;

      gdk_draw_line(win, gc, x1, y1 - start, x2, y2 - start);
    }
  }
}

void text_draw(GtkWidget *widget, GdkEventExpose *event, gpointer data)
{
  gtk_widget_draw_default(widget);
  draw_stroke(widget);
#ifdef DEBUG_PRINT
  printf(__FUNCTION__"\n");
#endif
}

gint text_event(GtkWidget *widget, GdkEvent *event, gpointer data)
{

#ifdef DEBUG_PRINT
  printf(__FUNCTION__":event->type: %d\n", event->type);
#endif
  switch(event->type){
  case GDK_BUTTON_PRESS:
    if(draw_flag){
      text_button_press(widget, (GdkEventButton *) event, data);
      return TRUE;
    }
    break;
  case  GDK_BUTTON_RELEASE:
    if(draw_flag){
      text_button_release(widget, (GdkEventButton *) event, data);
      return TRUE;
    }
    break;
  case  GDK_MOTION_NOTIFY:
    if(draw_flag){
      text_motion_notify(widget, (GdkEventMotion *) event, data);
      return TRUE;
    }else{
      text_draw(widget, (GdkEventExpose *) event, data);
    }
    break;

  case GDK_EXPOSE:
    gtk_widget_draw(widget, NULL);
    draw_stroke(widget);
    return TRUE;

  default:
#ifdef DEBUG_PRINT
    printf("type: %d\n", event->type);
#endif
    break;
  }

  return FALSE;
}

void scroll_event(GtkObject *object, GdkEvent *event, gpointer data)
{
#ifdef DEBUG_PRINT
  printf(__FUNCTION__": value: %f\n", GTK_ADJUSTMENT(object)->value);
#endif

  text_draw(memo_text, NULL, 0);
}

void text_changed(GtkWidget *widget, GdkEventExpose *event, gpointer data)
{
  GdkRectangle rect;

  rect.x = 0;
  rect.y = 0;
  rect.width = widget->allocation.width;
  rect.height = widget->allocation.height;
  gtk_widget_draw(widget, &rect);

#ifdef DEBUG_PRINT
  printf(__FUNCTION__"\n");
#endif
}

void undo_button_press(GtkWidget *widget, GdkEventButton *event, gpointer data)
{
  if(!draw_flag) return;

  if(n_stroke > 0) n_stroke--,undo++;

#ifdef DEBUG_PRINT
  printf(__FUNCTION__":stroke: %d\n", n_stroke);
#endif

  gtk_widget_draw(memo_text, NULL);
}

void redo_button_press(GtkWidget *widget, GdkEventButton *event, gpointer data)
{
  if(!draw_flag) return;

  if(undo > 0) n_stroke++, undo--;

#ifdef DEBUG_PRINT
  printf(__FUNCTION__":stroke: %d\n", n_stroke);
#endif

  gtk_widget_draw(memo_text, NULL);
}

void copy_command()
{
  
  if( disp_status == STATE_TOP){
    copy_text();
  }else{
    copy_memo();
  }

}

void copy_text()
{
  if(memo_text != NULL)
    gtk_editable_copy_clipboard(GTK_EDITABLE(memo_text));
}

void copy_memo()
{
  if(current_memos < 0) return;

  if(copy_str != NULL) free(copy_str);
  copy_str    = strdup(memos[current_memos]);
  copy_stroke = load_stroke(current_memos, copy_stk);

  has_copy = 1;
}

void cut_command()
{

  if( disp_status == STATE_TOP){
    cut_text();
  }else{
    cut_memo();
  }

}

void cut_text()
{
  if(memo_text != NULL)
    gtk_editable_cut_clipboard(GTK_EDITABLE(memo_text));
}

void cut_memo()
{
  if(current_memos < 0) return;

  copy_memo();

  if(memos[current_memos] != NULL){
    free(memos[current_memos]);
    memos[current_memos] = NULL;
    remove_memo(current_memos);
    n_stroke = 0;
    n_sample = 0;
    remove_stroke(current_memos);
  }
  gtk_clist_set_text(GTK_CLIST(list), current_memos, 1, NULL);
}

void paste_command()
{
  if( disp_status == STATE_TOP){
    paste_text();
  }else{
    paste_memo();
  }

}

void paste_text()
{
  if(memo_text != NULL)
    gtk_editable_paste_clipboard(GTK_EDITABLE(memo_text));
}

void yes_over_write(GtkWidget *widget, gpointer data)
{
  char *p;

  free(memos[current_memos]);
  memos[current_memos] = NULL;
  remove_memo(current_memos);
  n_stroke = 0;
  n_sample = 0;
  remove_stroke(current_memos);
  
  save_memo(current_memos, copy_str);
  memos[current_memos] = strdup(copy_str);
  save_stroke(current_memos, copy_stk, copy_stroke);
  
  p = get_first_line(memos[current_memos]);
  gtk_clist_set_text(GTK_CLIST(list), current_memos, 1, p);
  if(p) free(p);

  gtk_widget_destroy(GTK_WIDGET(data));
}

void no_over_write(GtkWidget *widget, gpointer data)
{
  gtk_widget_destroy(GTK_WIDGET(data));
}

void paste_memo()
{
  char *p;

  if(current_memos < 0) return;

  if(has_copy){
    if(memos[current_memos] != NULL){
      message_btn(_("Do you want to over write?"),
		  yes_over_write, no_over_write);
    }else{
      memos[current_memos] = strdup(copy_str);
      save_memo(current_memos, copy_str);
      save_stroke(current_memos, copy_stk, copy_stroke);

      p = get_first_line(memos[current_memos]);
      gtk_clist_set_text(GTK_CLIST(list), current_memos, 1, p);
      if(p) free(p);
    }
  }
}


void selall_text()
{
  if(memo_text != NULL)
    gtk_editable_select_region(GTK_EDITABLE(memo_text), 0,
			       gtk_text_get_length(GTK_TEXT(memo_text)));
}


void init_memo()
{
  memo_table = gtk_table_new(2, 2, FALSE);

  memo_text = gtk_text_new(NULL, NULL);
  gtk_text_set_editable(GTK_TEXT(memo_text), FALSE);

  gtk_signal_connect(GTK_OBJECT(memo_text), "event",
		     GTK_SIGNAL_FUNC(text_event), (gpointer)0);  

  gtk_signal_connect(GTK_OBJECT(memo_text), "changed",
		     GTK_SIGNAL_FUNC(text_changed), (gpointer)0);  

  gtk_signal_connect(GTK_OBJECT(memo_text), "draw",
		     GTK_SIGNAL_FUNC(text_draw), (gpointer)0);  

/*
**** 륦ɥ
  memo_vscroll = gtk_vscrollbar_new((GTK_TEXT(memo_text))->vadj);
*/

  gtk_signal_connect(GTK_OBJECT((GTK_TEXT(memo_text))->vadj),
		     "value_changed",
		     GTK_SIGNAL_FUNC(scroll_event), (gpointer)0);  

  gtk_table_attach(GTK_TABLE(memo_table), memo_text, 0, 1, 0, 1,
		   GTK_FILL|GTK_EXPAND, GTK_FILL|GTK_EXPAND, 0, 0);  
  
/*
**** 륦ɥ
  gtk_table_attach(GTK_TABLE(memo_table), memo_vscroll, 1, 2, 0, 1,
		   GTK_SHRINK, GTK_FILL|GTK_EXPAND, 0, 0);  
*/

/*
**** 륦ɥ
  gtk_widget_show(memo_vscroll);
*/
  gtk_widget_show(memo_text);

  gtk_widget_show(memo_table);
}

void
toggled(GtkWidget *toggle, GdkEvent *event, gpointer data)
{
  draw_flag = GTK_TOGGLE_BUTTON(toggle)->active;

  if( draw_flag ){
    set_display_state( STATE_DRAW );
  }else{
    set_display_state( STATE_WRITE );
  }
}

GtkWidget *
create_button( char *label, GtkSignalFunc func, int num)
{
  GtkWidget *btn;

  btn = gtk_button_new_with_label(label);

  if(func != NULL)
#if 1 /* kon  2001/Aug/31 */
    gtk_signal_connect(GTK_OBJECT(btn), "clicked",
		       GTK_SIGNAL_FUNC(func), (gpointer)num);
#else
    gtk_signal_connect(GTK_OBJECT(btn), "button_press_event",
		       GTK_SIGNAL_FUNC(func), (gpointer)num);
#endif

  gtk_widget_show(btn);

  return btn;
}


void
init_notebook()
{
  int i;
  GtkWidget *label;
  GtkWidget *dummy;

  notebook = gtk_notebook_new();
  gtk_notebook_set_tab_pos(GTK_NOTEBOOK(notebook), GTK_POS_TOP);
  gtk_notebook_set_scrollable( GTK_NOTEBOOK(notebook), TRUE );

  /*
  ** ǽΥڡơʹߤƥ
  */
  for( i=0; i<=array_tail_cate; i++ ){

    if( i==0 ){
      label = gtk_label_new( _("All") );
    }else{
      label = gtk_label_new( c_array[i-1] );
    }
    dummy = gtk_fixed_new();
    gtk_widget_show( label );
    gtk_widget_show( dummy );
    gtk_notebook_append_page( GTK_NOTEBOOK(notebook), dummy, label );

  }

  gtk_widget_show( notebook );

  gtk_signal_connect (GTK_OBJECT (notebook), "switch_page",
                      GTK_SIGNAL_FUNC (switch_page), NULL);

}

void
create_top_win()
{
  GtkWidget *buttons_top;

  main_container_top_vbox = gtk_vbox_new( FALSE, 0 );

  /*
  ** ɽΰ
  */
  init_list();

  buttons_top   =  gtk_table_new(1, 3, TRUE);

  /* ̻Υܥ */
  btnNew = create_button( _("New"),   press_new_button, 0);
  gtk_table_attach(GTK_TABLE(buttons_top), btnNew, 0, 1, 0, 1,
		   GTK_FILL|GTK_EXPAND, GTK_SHRINK, 0, 0);  


  gtk_box_pack_start( GTK_BOX(main_container_top_vbox), list_table, TRUE, TRUE, 0 );
  gtk_box_pack_start( GTK_BOX(main_container_top_vbox), buttons_top, FALSE, FALSE, 0 );

  gtk_widget_show( buttons_top );
  gtk_widget_show( main_container_top_vbox );
}

void create_view_win()
{
  GtkWidget *sw;
  GtkWidget *buttons_vbox;
  GtkWidget *draw_left_vbox;
  GtkWidget *draw_center_vbox;
  GtkWidget *draw_right_vbox;

  main_container_view_vbox = gtk_vbox_new( FALSE, 0 );

  sw = gtk_scrolled_window_new( NULL, NULL );

  gtk_box_pack_start( GTK_BOX(main_container_view_vbox), sw, TRUE, TRUE, 0 );

  gtk_scrolled_window_set_policy( GTK_SCROLLED_WINDOW(sw),
				  GTK_POLICY_NEVER,
				  GTK_POLICY_AUTOMATIC );

  gtk_widget_show(sw);

  /*
  ** Խΰκ
  */
  init_memo();

  buttons_vbox = gtk_vbox_new( FALSE, 0 );
  buttons_view = gtk_table_new(1, 3, TRUE);

  /* ܺٲ̻Υܥ */
  btnEdit = create_button( _("Edit"),   press_edit_button, 0);
  gtk_table_attach(GTK_TABLE(buttons_view), btnEdit, 0, 1, 0, 1,
		   GTK_FILL|GTK_EXPAND, GTK_SHRINK, 0, 0);  

  btnDelete = create_button( _("Delete"),   press_del_button, 0);
  gtk_table_attach(GTK_TABLE(buttons_view), btnDelete, 1, 2, 0, 1,
		   GTK_FILL|GTK_EXPAND, GTK_SHRINK, 0, 0);  

  btnReturn = create_button( _("Return"),   press_return_button, 0);
  gtk_table_attach(GTK_TABLE(buttons_view), btnReturn, 2, 3, 0, 1,
		   GTK_FILL|GTK_EXPAND, GTK_SHRINK, 0, 0);  

  gtk_box_pack_start( GTK_BOX(buttons_vbox), buttons_view, FALSE, FALSE, 0 );

  gtk_widget_show(buttons_view);

  /* Խ̻Υܥ */
  buttons_write = gtk_table_new(1, 3, TRUE);
  draw_left_vbox    = gtk_vbox_new( TRUE, 0 );
  draw_center_vbox  = gtk_vbox_new( TRUE, 0 );
  draw_right_vbox   = gtk_vbox_new( TRUE, 0 );

  /* 񤭥ܥ */
  draw_toggle = gtk_toggle_button_new_with_label(_("Hand"));
  gtk_signal_connect(GTK_OBJECT(draw_toggle), "toggled",
		     GTK_SIGNAL_FUNC(toggled), 0);

  gtk_widget_show( draw_toggle );

  gtk_box_pack_start( GTK_BOX(draw_left_vbox),
		      draw_toggle, FALSE, FALSE, 0 );

  lblDummy = gtk_label_new("");

  gtk_box_pack_start( GTK_BOX(draw_left_vbox),
		      lblDummy, FALSE, FALSE, 0 );

  /*
  ** ɥܥϼ񤭻ˤФƤʤ
  */
  /* ɥܥ */
  btnUndo = create_button( _("Undo"),   undo_button_press, 0);
  gtk_box_pack_start( GTK_BOX(draw_center_vbox), btnUndo, FALSE, FALSE, 0 );

  /* Ͽܥ */
  btnAdd = create_button( _("Add"),   press_add_button, 0);
  gtk_box_pack_start( GTK_BOX(draw_center_vbox), btnAdd, FALSE, FALSE, 0 );


  /*
  ** ɥܥϼ񤭻ˤФƤʤ
  */
  /* ɥܥ */
  btnRedo = create_button( _("Redo"),   redo_button_press, 0);
  gtk_box_pack_start( GTK_BOX(draw_right_vbox), btnRedo, FALSE, FALSE, 0 );

  /* åܥ */
  btnCancel = create_button( _("Cancel"),   press_cancel_button, 0);
  gtk_box_pack_start( GTK_BOX(draw_right_vbox), btnCancel, FALSE, FALSE, 0 );


  gtk_table_attach(GTK_TABLE(buttons_write), draw_left_vbox,
		   0, 1, 0, 1,
		   GTK_FILL|GTK_EXPAND, GTK_SHRINK, 0, 0);

  gtk_table_attach(GTK_TABLE(buttons_write), draw_center_vbox,
		   1, 2, 0, 1,
		   GTK_FILL|GTK_EXPAND, GTK_SHRINK, 0, 0);

  gtk_table_attach(GTK_TABLE(buttons_write), draw_right_vbox,
		   2, 3, 0, 1,
		   GTK_FILL|GTK_EXPAND, GTK_SHRINK, 0, 0);

  gtk_box_pack_start( GTK_BOX(buttons_vbox), buttons_write, FALSE, FALSE, 0 );

  gtk_widget_show(draw_left_vbox);
  gtk_widget_show(draw_center_vbox);
  gtk_widget_show(draw_right_vbox);
  gtk_widget_show(buttons_write);

/**
  gtk_box_pack_start( GTK_BOX(main_container_view_vbox), memo_table, TRUE, TRUE, 0 );
**/
  gtk_scrolled_window_add_with_viewport( GTK_SCROLLED_WINDOW(sw), memo_table );
  gtk_box_pack_start( GTK_BOX(main_container_view_vbox), buttons_vbox, FALSE, FALSE, 0 );

  gtk_widget_show(memo_table);
  gtk_widget_show(buttons_vbox);


  gtk_widget_show( main_container_view_vbox );
}

/*
** ɥɽ
*/
void
create_main_window()
{
  /*
  ** ֥ȥκʥƥ̡
  */
  init_notebook();

  gtk_box_pack_start( GTK_BOX(main_container_vbox), notebook, FALSE, FALSE, 0 );

  create_top_win();
  create_view_win();

  gtk_box_pack_start( GTK_BOX(main_container_vbox), main_container_top_vbox, TRUE, TRUE, 0 );
  gtk_box_pack_start( GTK_BOX(main_container_vbox), main_container_view_vbox, TRUE, TRUE, 0 );

  set_display_state( STATE_TOP );
}


int main(int argc, char **argv)
{
  GtkWidget *app;
  int status;

  status = SGCheckDinvoke(argv[0]);
  if(status > 0) return -1;

  bindtextdomain(PACKAGE, PACKAGE_LOCALE_DIR);
  textdomain(PACKAGE);

  gtk_set_locale();

  gnome_init (PACKAGE, VERSION, argc, argv);
  app = gnome_app_new(PACKAGE, _("sgmemo"));

  gtk_signal_connect (GTK_OBJECT (app), "delete_event",
		      GTK_SIGNAL_FUNC (quit), NULL);

  gnome_app_create_menus(GNOME_APP(app), main_menu);

  main_container_vbox = gtk_vbox_new( FALSE, 0 );
  gnome_app_set_contents(GNOME_APP(app), main_container_vbox );

  /*
  ** ƥμ($HOME/sgcategory)
  */
  load_category_data();

  /*
  ** ȥƥбդեɤ߹
  */
  load_memo_list();

  /*
  ** ե֤̾˵ͤ褦˥͡ह
  ** ĤǤ˥ƥ⤽Ϣư
  */
  status = renumber_filename();
  if( status != 0 ){
    gtk_main_quit();
    exit( 0 );
  }

  /*
  ** ̤
  */
  create_main_window();

  gtk_widget_show( main_container_vbox );
  gtk_widget_show(app);
  
  gtk_main();

  /*
  ** ȥƥбդե¸
  */
  save_memo_list();

  return 1;
}
